require 'fileutils'
class PublicacionsController < ApplicationController
	
  #Muestra la lista de publicaciones en las que participa el miembro identificado
  def index
    if (session[:user_id] == nil || session[:user_id] == "")
       redirect_to login_path
    else
      @miembro = Autor.find(session[:user_id])
      @participaciones = @miembro.participacions
    end
  end

#Método show: recupera los datos de la publicación y sus archivos
   def show 
    if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
        @miembro = Autor.find(session[:user_id])
        @publicacion = Publicacion.find(params[:id])
        @participaciones = @publicacion.participacions
        params[:participaciones] =  "SELECT autor_id FROM participacions WHERE publicacion_id = #{@publicacion.id}"
        @autores = Autor.where("id NOT IN (#{params[:participaciones]})")
        
        @archivos = Archivo.where(:publicacion => @publicacion)
      end
   end


#Método edit: recupera los datos de la publicación y se muestran para editarles

   def edit 
    
    if (session[:user_id] == nil || session[:user_id] == "")
       redirect_to login_path
  
    else
      @miembro = Autor.find(session[:user_id])
      @publicacion = Publicacion.find(params[:id])
    end
  end

#Método update: actualiza los datos de la publicacion 
def update
       
       @miembro = Autor.find(session[:user_id])
       @publicacion = Publicacion.find(params[:id])
 
       if @publicacion.update(publicacion_params)
                  
          redirect_to publicacion_path(@publicacion)
         

      else
        render 'edit'
      end

end

#Muestra el formulario que permite crear la publicación. En ese formulario también se pueden indicar los 
#autores que van a participar en esa publicacion
def new
  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
  else
      @miembro = Autor.find(session[:user_id])
      @publicacion = Publicacion.new

      if params[:lista]
        #En el desplegable de autores a añadir se muestran todos menos el miembro que inicia la 
        #creción, evitando así que pueda añadirse de nuevo
        @participaciones = params[:lista]
        @tipo = params[:tipo]
        @autores = Autor.where("id NOT IN (?)", @participaciones)

      else
      @tipo = params[:publicacion][:tipo]      
      @participaciones = Array.new
      @participaciones << @miembro.id
      @autores = Autor.where("id != #{@miembro.id}")
    end
  end
end

#Método create: Crea una nueva publicación y las participaciones de esa publicación
	
	def create

    @miembroactoractual = 0
     

      @publicacion = Publicacion.new(publicacion_params)
       if@publicacion.save
         @miembro = session[:user_id]

          @participaciones = params[:publicacion][:lista]

          @participaciones.each do |participacion|
              @autor = Autor.find(participacion.to_i)
              if(@autor.id == session[:user_id])
                @miembroactoractual = 1
              end
              @participacion = @publicacion.participacions.create(autor_id: @autor.id)

          end

         #Comprueba si el miembro que ha iniciado la creación de la publicación esta presente 
         #entre los autores o no. 
          if @miembroactoractual == 1
            redirect_to publicacion_path(@publicacion)
          else
            flash[:mensaje] = "Se ha creado la publicación correctamente"
            redirect_to autor_path(@miembro)
          end
       else 
        @participaciones = params[:publicacion][:lista]
        @miembro = Autor.find(session[:user_id])
        @tipo = params[:publicacion][:tipo]
        @autores = Array.new

        listadoauxiliar = params[:publicacion][:listaposautores]
          listadoauxiliar.each do |autoraux|
              autor = Autor.find(autoraux)
              @autores << autor
          end
        render  'new'
       end
      
 	 end
 	
#Método destroy: Elimina la publicación 
    def destroy
    	@miembro = Autor.find(session[:user_id])
  		@publicacion = Publicacion.find(params[:id])
  		@publicacion.destroy
      redirect_to publicacions_path(@miembro)
        
    end

#Método listado: Recupera todas las publicaciones 
def listado
    	#@publicaciones =Publicacion.all
      
        @pubs = Publicacion.paginate(:page => params[:page], :per_page => 2)

         @yearsaux = Publicacion.select("anyo").paginate(:page => params[:page], :per_page => 1).distinct
      #@yearsaux = Publicacion.select("extract(YEAR FROM created_at) as year ").distinct

          @years = Publicacion.select("anyo").paginate(:page => params[:page], :per_page => 1).order("anyo desc").distinct
    


end


#Comprueba si los datos para la busqueda son válidos y los transforma para poder realizar la busqueda
    def buscador

      if(params[:publicacion][:autor] == "" && params[:publicacion][:titulo] == "" &&  params[:publicacion][:year] == "false")
        flash[:mensaje] = "Debe rellenar al menos uno de los campos para realizar la busqueda"
          redirect_to root_path

    else

             session[:buscador_autor] = params[:publicacion][:autor].downcase
             session[:buscador_titulo] = params[:publicacion][:titulo].downcase
             if(params[:publicacion][:year] == "false")
              session[:buscador_year] =""
            else
              session[:buscador_year] = params[:publicacion][:year].to_f
             end
             redirect_to resultado_publicacions_path
    end


      

end


#Realiza la busqueda de publicaciones con los parámetros introducidos
def resultado 


   #Si titulo esta vacio miramos el resto de elementos de busqueda
   if(session[:buscador_titulo] == "")
      #Si el autor esta vacío al menos tiene que haber año o no habriamos llegado hasta aqui
      if(session[:buscador_autor] == "")

        @publicacionesresultado = Publicacion.where("anyo = #{session[:buscador_year]}")
      
     #Si el autor no esta vacio 
     else
          params[:autores]= "SELECT id FROM autors WHERE lower(nombre) LIKE '%#{session[:buscador_autor]}%' OR lower(apellido) LIKE '%#{session[:buscador_autor]}%' OR CONCAT(lower(nombre),' ', lower(apellido))  LIKE '%#{session[:buscador_autor]}%'  "
        params[:participaciones] = "SELECT publicacion_id FROM participacions WHERE autor_id IN (#{params[:autores]})"

        #Si el año esta vacio
        if(session[:buscador_year] == "")
          @publicacionesresultado = Publicacion.where("id IN (#{params[:participaciones]})")
        else        
        @publicacionesresultado = Publicacion.where("id IN (#{params[:participaciones]}) AND anyo = #{session[:buscador_year]}")
        end
        
      end
      
   #si titulo no esta vacio 
    else
    #si autor esta vacio miramos solo titulo 
        if session[:buscador_autor] == ""
          if( session[:buscador_year] == "")
            @publicacionesresultado = Publicacion.where("lower(titulo) LIKE '%#{session[:buscador_titulo]}%'")
          else
            @publicacionesresultado = Publicacion.where("lower(titulo) LIKE '%#{session[:buscador_titulo]}%' AND anyo = #{session[:buscador_year]}")
          end
        else
              #si los dos tienen datos buscamos los dos 
         params[:autores]= "SELECT id FROM autors WHERE lower(nombre) LIKE '%#{session[:buscador_autor]}%' OR lower(apellido) LIKE '%#{session[:buscador_autor]}%' OR CONCAT(lower(nombre),' ', lower(apellido))  LIKE '%#{session[:buscador_autor]}%'"
       #@participanesbusqueda = Participacion.select("id_publicacion").where("id_miembro IN (#{params[:autores]})")
        params[:participaciones] = "SELECT publicacion_id FROM participacions WHERE autor_id IN (#{params[:autores]})"
          if(session[:buscador_year] == "")
              @publicacionesresultado = Publicacion.where("id IN (#{params[:participaciones]}) AND lower(titulo) LIKE '%#{session[:buscador_titulo]}%'")
          else
              @publicacionesresultado = Publicacion.where("id IN (#{params[:participaciones]}) AND lower(titulo) LIKE '%#{session[:buscador_titulo]}%'  AND anyo = #{session[:buscador_year]}")

          end
      
        end
      
    end
 
      

     if(@publicacionesresultado.blank?)
        flash[:mensaje] = "No se han encontrado resultados"
      else 
         flash[:mensaje] = ""
      end


  end


#genera y muestra el bibtex de la publicacion
def mostrarbibtex
  @publicacion = Publicacion.find(params[:publicacion_id])
 params[:participaciones] = "SELECT autor_id FROM participacions WHERE publicacion_id = #{@publicacion.id}"
  @autoresaux = Autor.select('nombre, apellido').where("id IN (#{params[:participaciones]})")

@autores = ""

    @autoresaux.each do |autor|

        @autores = "#{@autores}"+"   #{autor.apellido}, #{autor.nombre} and"
        
    end

  bib = BibTeX::Bibliography.new
  bib << BibTeX::Entry.new({
     :author => @autores,
    :bibtex_type => @publicacion.tipo,
    :type => @publicacion.tipo,
   :booktitle => @publicacion.titulolibro,
   :edition => @publicacion.edicion,
   :publisher => @publicacion.editor,
   :series => @publicacion.series,
   :title => @publicacion.titulo,
   :resumen => @publicacion.resumen,
   :year => @publicacion.anyo
})
  
   flash[@publicacion.id] = bib.to_s

   if params[:resultado] 
    redirect_to resultado_publicacions_path()
  else

redirect_to "/publicacions/listado?page=#{params[:page]}"
end
  
end


#aqui el miembro selecciona que tipo de publicación quiere añadir
def tipopublicacion 
if (session[:user_id] == nil || session[:user_id] == "")
       redirect_to login_path
else

  @miembro = Autor.find(session[:user_id])
end

end

   

 	private
  		def publicacion_params
    		params.require(:publicacion).permit(:titulo, :resumen, :anyo ,:tipo , :paginas, :volumen, :numero, :periodico, :editor , :organizacion, :titulolibro, :series, :escuela , :institucion, :capitulo, :edicion)
  		end

      def participacion_params
         params.require(:participacion).permit(:autor_id)
      end

   end


