class Autor < ApplicationRecord

    #relación un autor tiene 0 o mas participaciones
	has_many :participacions , dependent: :destroy
	
	#comprobaciones de los datos obligatorios para los autores
	validates :nombre, :presence=> {message: "Debe introducir un nombre"} , :length => { minimum: 3 , too_short: "El nombre debe tener al menos tres caracteres"} , :uniqueness =>{scope: [:apellido] , message: "Ya existe un autor (colaborador o miembro) con este nombre , introduzca otro distintivo"}
	validates :apellido, :presence => {message: "Debe introducir un apellido"}, :length => { minimum: 3 , too_short: "El apellido debe tener al menos tres caracteres"} 
	validates :departamento , presence: {message: "Debe introducir un departamento"} , length: {minimum:4 , too_short:"El nombre del departamento debe tener minimo 4 caracteres"} , if:  :miembro?
    validates :login , presence: {message: "Debe introducir un login "} , uniqueness: {message: "Ya existe un miembro con ese login"}, if:  :miembro?
    validates :pass ,presence: {message: "Debe introducir un password "} , length: {minimum: 6 , too_short: "El password debe tener 6 caracteres como mínimo"} , if:  :miembro?

	def miembro?
         (rol == 'Administrador' || rol == 'Miembro')

	end
end
