class Publicacion < ApplicationRecord

	#Relacion una publicacion tiene 0 o mas archivos y 1 o mas participaciones
	has_many :archivos , dependent: :destroy
	has_many :participacions , dependent: :destroy

     #Validación de los datos obligatorios para publicaciones segun su tipo
	validates :titulo, :presence=>{message: "Debe rellenar el titulo"} , :uniqueness => {message: "Ya existe una publicación con el mismo título"}
	validates_numericality_of  :anyo , :presence =>{message: "Debe rellenar el año y debe ser igual o menor que el actual"} , :less_than_or_equal_to => Time.current.year , message: "Debe ser igual o menos que 2017"
	validates :escuela , :presence=>{message: "Debe rellenar la escuena"} , if: :phdThesis?
    validates :periodico , :presence=>{message: "Debe rellenar el periodico o revista"} , if: :article?
    validates :titulolibro , :presence=>{message: "Debe rellenar el titulo del libro" } , if: :inProceedings?
    validates :editor , :presence=>{message: "Debe rellenar el editor"}, if: :book?
    validates :capitulo , :presence=>{message: "Debe rellenar el capitulo"}, if: :inBook?
    validates :paginas , :presence=>{message: "Debe rellenar las paginas"}, if: :inBook?


    
   
	def article?
		tipo == 'Article'
	end

	def inProceedings?
		tipo == 'InProceedings'
	end

	def phdThesis?
		tipo == 'PhdThesis'
	end

	def techReport?
		tipo == 'TechReport'
	end

	def inBook?
		tipo == 'InBook'
	end
	def book?
		tipo == 'Book' || tipo == 'InBook'
	end


end
